
if not m then
    m = mqtt.Client(myClient, 60, login, pass)
    m:lwt(myClient..'/state', "OFF", 0, 1)
    m:on("message", function(conn, topic, dt)
        local top = string.gsub(topic, myClient.."/command/","")
        print('Got now:',top, ":", dt)
        if dt then
            table.insert(killtop, {top, dt})
            if not dat.analiz then
                dofile("analize.lua")
            end
        end
    end)
    m:on("offline", function(con)
        dat.broker = false
        dofile('setmqtt.lua')
    end)
end

m:close()

local count = 0
local connecting = function(getmq)

    if wifi.sta.status() == 5 then
        print('Got wifi')        
        tmr.stop(getmq)
        tmr.unregister(getmq)
        getmq = nil
        print(Broker..'!!!!!!!')
        m:connect(Broker, port, 0, 0,
        function(con)
            print("Connected to Broker")
            m:subscribe(myClient.."/command/#",0, function(conn)
                print("Subscribed.")
            end)
            m:publish(myClient..'/state',"ON",0,1)
            dat.broker = true
            count = nil
        end,
        function(con, reason)
            print("failed mqtt: " .. reason)
            dofile('setmqtt.lua')
        end)
    else
        print("Wating for WiFi "..count.." times")
        count = count + 1
        if count > 20 then node.restart() end
    end
end

tmr.create():alarm(5000, 1, function(t)
    connecting(t)
end)
